#ifndef _FIXED_H
#define _FIXED_H

/* fixed.h -=- ported from Zen Of Graphics Programming w/o rounding junk
   by Brennan Underwood (brennan@rt66.com) */
/* ABSOLUTELY NO WARRANTY!!!!!! */
/* Jun 04 97 - Stupid bug in FixedMul fixed, thanks to Elliot Oti
                                             e.oti@stud.warande.ruu.nl) */

typedef long int Fixedpoint;
#define INT_TO_FIXED(x) (((long)(int)x) << 16)
#define DOUBLE_TO_FIXED(x) ((long) (x * 65536.0 + 0.5))
#define FIXED_TO_DOUBLE(x) (((double)x) / 65536.0)
#define FIXED_TO_INT(FixedVal) ((int) (FixedVal >> 16))
#define ROUND_FIXED_TO_INT(FixedVal) \
   ((int) ((FixedVal + DOUBLE_TO_FIXED(0.5)) >> 16))

static inline Fixedpoint FixedMul(Fixedpoint p1, Fixedpoint p2) {
  Fixedpoint ret;
  asm (
        "imull %%ebx\n"
        "shrdl $16, %%edx,%%eax\n"
        /*"shrl $16, %%eax\n" */
       : "=a" (ret)
       : "a" (p1), "b" (p2) );
  return ret;
}

static inline Fixedpoint FixedDiv(Fixedpoint dividend, Fixedpoint divisor) {
  Fixedpoint ret;
  asm (
        "xorl %%eax, %%eax\n"
        "shrdl $16, %%edx, %%eax\n"
        "sarl $16, %%edx\n"
        "idivl %%ecx\n"
        "shld $16, %%eax, %%edx\n"
        : "=a" (ret)
        : "d" (dividend), "c" (divisor)
        : "%edx" );
  return ret;
}

#endif