#ifndef _LEVEL_H
#define _LEVEL_H

typedef struct tagGROUPINFO {
  unsigned long offset;       // Where the information begins.
  unsigned long length;         // The size of the information.
  char id[13];                // This will be just an identification.
} GROUPINFO;

struct list {
  GROUPINFO gi;
  struct list *nextInfo;
};

typedef struct list LIST;
typedef LIST *LISTPTR;
extern LISTPTR listHead;

extern void ReadLevelData(char *levelFile);
extern void FreeListMem(void);
extern LISTPTR AddToList(GROUPINFO gInfo, LISTPTR prevRec);
extern int FindResource(GROUPINFO *gInfo, char *id);
extern void LoadLinkedList(char *fileName);
extern void BuyStuff(void);


#endif

