#ifndef _MISC_H
#define _MISC_H

extern void InitVariables(void);
extern void InitLists(void);
extern void FreeMemory(void);
extern int IsParam(int numArgs, char *args[], char *find);
extern void LoadPalette(char *pal);
extern void LoadSetupFile(void);
extern void AddExplosion(int x, int y, int type, int delay);
extern int WeaponDamage(int type);
extern int HaveWeapon(int type, int weapons);
extern void AddPowerUp(int type, int x, int y);
extern void UsePowerUp(int type);
extern void StandardExplosion(int x, int y, int type, int delayFactor);
extern void ShowPlayerDie(void);
extern int FileExist(char *fname);


#endif

